{ bp }

(*
 * Problem  :   DIVIDE
 * Contest  :   UOI-2007 (Kremenchug)
 * Type     :   Solution
 * Date     :   March 30, 2007
 * Version  :   1.1
 * Author   :   Taras Galkovsky / Bogdan Rubl'ov
 * Language :   C++
 * Compiler :   VC 6.0, GCC 3.4
 * Algorithm:   Author Solution
 *)

program divide;
const
  eps : real = 1e-9;

function next (x, n : integer) : integer;
begin
     next := ((x)mod n) + 1;
end;

type
  point = record
    x, y : real;
  end;

procedure minus (a, b : point; var c:point);
begin
  c.x := a.x-b.x;
  c.y := a.y-b.y;
end;

function vprod (a, b : point) : real;
begin
  vprod := a.x*b.y - a.y*b.x;
end;

function vprods (a, b : point) : integer;
  var
    p : real;
begin
  p := vprod(a,b);
  if (p > eps) then vprods := 1
  else if (p < -eps) then vprods := -1
  else vprods := 0;
end;

var
  n : array [1..2] of integer;
  p : array [1..2, 1..30] of point;
  isections : array [1..2, 1..2] of integer;

function intersects (a, b, c, d : point) : boolean;
  var
    ba, ca, da, dc, ac, bc : point;
begin
  minus(b,a,ba);
  minus(c,a,ca);
  minus(d,a,da);
  minus(d,c,dc);
  minus(a,c,ac);
  minus(b,c,bc);
    if (vprod(ba, ca) * vprod(ba, da) <= 0) and
       (vprod(dc, ac) * vprod(dc, bc) <= 0) then
        intersects := true
    else
        intersects := false;
end;

procedure intersect (a, b, c, d : point; var res : point);
  var
    dd, d1, x : real;
    _b, _d : point;
begin
  minus(b,a,_b);
  minus(d,c,_d);
  b := _b;
  d := _d;
  dd := b.x * (-d.y) - b.y * (-d.x);
  D1 := (c.x-a.x) * (-d.y) - (c.y-a.y) * (-d.x);
  x := D1/dd;
  res.x := a.x + x * b.x;
  res.y := a.y + x * b.y;
end; 

var
   i, j, k : integer;
   x, y, z, cur : integer;
   fi, fo : Text;
   res : point;
begin
   assign(fi, 'divide.dat');
   assign(fo, 'divide.sol');
   reset(fi);
   rewrite(fo);

    for j := 1 to 2 do
    begin
         readln(fi, n[j]);
         for i := 1 to n[j] do
         begin
            readln(fi, x, y);
            p[j,i].x := x;
            p[j,i].y := y;
        end;
    end;

  k := 1;
  for i := 1 to n[1] do
    for j := 1 to n[2] do
      if (intersects(
	    p[1,i],
	    p[1,next(i,n[1])],
            p[2,j],
            p[2,next(j,n[2])]) ) then
	      begin
		isections[1,k] := i;
		isections[2,k] := j;
		k:=k+1;
	      end;

  for i := 1 to 2 do begin
    intersect(p[1,isections[1,i]],
              p[1,next(isections[1,i],n[1])],
              p[2,isections[2,i]],
              p[2,next(isections[2,i],n[2])],
              res);
    write(fo, res.x:0:3, ' ', res.y:0:3);
    if (i = 1) then write(fo, ' ');
  end;

  writeln(fo);

{  close(fi);}
  close(fo);
end.
