/* gcc_cpp */

/*
 * Problem  :   Drawing
 * Contest  :   UOI-2007 (Kremenchug)
 * Type     :   Solution
 * Date     :   April 4, 2007
 * Version  :   2.0
 * Author   :   Volodymyr Tkachuk
 * Language :   C++
 * Compiler :   GCC 3.4.2
 * Algorithm:   Brood Force Solution (only for small fields)
 */
#include <fstream>
using namespace std;
const char* inputfile  = "drawing.dat";
const char* outputfile = "drawing.sol";
const int maxN = 100;

bool field[maxN][maxN];
bool tmpfield[maxN][maxN];
int N,M,w,b,g;

void ReadData(){
	ifstream in(inputfile);
	in>>N>>M>>w>>b>>g;
	char c;
	for(int i=0; i<N; ++i)
		for(int j=0; j<M; ++j){
			in>>c;
			field[i][j]=(c=='W');
		}
	in.close();
}

void WriteData(int answer){
	ofstream out(outputfile);
	out<<answer<<endl;
	out.close();
}
int answer;
int Tax(int i, int j){
	int ans = 0;
	if (field[i][j] && !tmpfield[i][j])
		ans+=b;
	if (!field[i][j] && tmpfield[i][j])
		ans+=w;
	if (j>0 && tmpfield[i][j-1]!=tmpfield[i][j])
		ans+=g;
	if (i>0 && tmpfield[i-1][j]!=tmpfield[i][j])
		ans+=g;
	return ans;
}
void WriteAns(){
	ofstream out ("out.log");
	for(int i = 0; i<N; ++i){
		for(int j = 0; j<M; ++j)
			out<<(tmpfield[i][j] ? 'W' : 'B');
		out<<endl;
	}
	out.close();
}
void BroodForce(int i, int j, int tmpanswer){
	if (answer<=tmpanswer) 
		return;
	if (j==M){
		j = 0;
		++i;
	}
	if (i == N){
		answer=tmpanswer;
		WriteAns();
	}
	tmpfield[i][j] = field[i][j];
	BroodForce(i,j+1,tmpanswer+Tax(i,j));
	tmpfield[i][j] = !field[i][j];
	BroodForce(i,j+1,tmpanswer+Tax(i,j));
}

int main(){
	ReadData();
	answer = 1000000000;
	BroodForce(0,0,0);
	WriteData(answer);
	return 0;
}