/* gcc_cpp */

/* 
 * Problem  : Order
 * Contest  : UOI-2007 (Kremenchug)
 * Type     : Solution
 * Date     : April 1, 2007
 * Version  : 1.0
 * Author   : Andrii Grynenko
 * Language :	C++
 * Compiler :	GNU C++
 * Algorithm:	Author Solution (simple dymamic, slow)
 */
 
#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define INF 1000000000000000000LL

int main ()
{
	int n;
	
	freopen ("order.dat", "r", stdin);
	freopen ("order.sol", "w", stdout);
	
	scanf ("%d", &n);
	
	vector <int> orders(n+1);
	
	for (int i=0; i<n; i++)
		scanf ("%d", &orders[i+1]);
	
	vector <long long> r (n, INF);
	r[0] = 0;
	long long res_c = 0;
	
	for (int i=0; i<n; i++)
	{
		long long add = abs (orders[i]-orders[i+1]);
		long long rr = INF;
		for (int j=0; j<=i; j++)
			rr = min (rr, abs(orders[i+1]-orders[j])+r[j]-add);
		r[i] = min (r[i], rr);
		res_c+=add;
	}
	
	long long res = INF;
	for (int i=0; i<=n; i++)
		res = min (res, r[i]);

	cout << (res+res_c) << endl;
	
	
	return 0;
}

