{fp}
{
* Problem  : Trees
* Contest  : UOI-2007 (Kremenchug)
* Type     : Solution
* Date     : March 26, 2007
* Version  : 1.0
* Author   : Volodymyr Tkachuk
* Language : Pascal
* Compiler : Free Pascal 2.0.4
* Algorithm: Autor Solution (Binary search)
}
const inputfile : string = 'trees.dat';
      outputfile: string = 'trees.sol';
      Nmax      = 1000;
      MaxDist   : longint = 1000000000;

var   N         : integer;
      Distance  : array[1..Nmax,1..Nmax] of longint;
      mind,maxd : longint;
      middle    : longint;
      answer    : longint;

{Read input data}
procedure ReadData;
var i,j : integer;
begin
 Assign(input,inputfile);
 reset(input);
 readln(N);
 for i:=1 to N-1 do
  for j:=i+1 to N do
   begin
    read(Distance[i][j]);
    Distance[j][i]:=Distance[i][j]
   end;
 close(input)
end;

{Write answer to output}
procedure WriteData;
begin
 Assign(output,outputfile);
 rewrite(output);
 writeln(answer);
 close(output);
end;

{Get minimal and maximal distance between to trees}
procedure GetMinMax;
var i,j : integer;
begin
 mind:= MaxDist;
 maxd:= -1;
 for i:=1 to N-1 do
  for j:=i+1 to N do
   begin
    if Distance[i][j]>maxd then
      maxd:=Distance[i][j];
    if Distance[i][j]<mind then
      mind:=Distance[i][j]
   end
end;


var checkarr : array[1..Nmax] of byte;
{DFS}
function Fill(ind, color : integer) : boolean;
var i : integer;
begin
 if (checkarr[ind]=0) then
  begin
   checkarr[ind]:=color;
   for i:=1 to N do
    if (i<>ind) and (Distance[ind][i]>middle) and not Fill(i,3-color) then
      begin
       Fill:=false;
       exit
      end;
   Fill:=true
  end
 else
  Fill:=(checkarr[ind]=color)
end;

{Check if it is possible to divide all trees into two sets in such way,
that distance between any 2 trees in one set less or equal then middle.
Simple DFS}
function CanDivide : boolean;
var i : integer;
begin
 fillchar(checkarr,sizeof(checkarr),0);
 for i:=1 to N do
  if (checkarr[i]=0) and not Fill(i,1) then
    begin
     CanDivide:=false;
     exit;
    end;
 CanDivide:=true;
end;

{Find solution using binary search}
function Solve : longint;
begin
 if N = 2 then
  begin
   Solve := 0;
   exit;
  end;
 while (maxd>mind) do
  begin
   middle:=(maxd+mind) div 2;
   if CanDivide then
    maxd:=middle
   else
    mind:=middle+1
  end;
 Solve:= maxd;
end;

begin
 ReadData;
 GetMinMax;
 answer:=Solve;
 WriteData
end.